itcl_class kdSelection {
    inherit kdBase
    public owner

    constructor {config} {
	$w addtag selected withtag $owner
	$w addtag cl_sel withtag $item
	addf_Tags $owner $item
    }
    destructor {
	$w dtag $owner selected
    }
}

itcl_class sel_rec {
    inherit kdSelection
    constructor {coords config} {
	seteach {x11 y11 x22 y22} $coords
	set i [$w create rec $x11 $y11 $x22 $y22 \
		-outline red]
	set item sel$i
	$w addtag $item withtag $i
	
	foreach xx [list $x11 $x22] {
	    foreach yy [list $y11 $y $y22] {
		kdCreateBox $w $xx $yy $item
	}   }
	kdCreateBox $w $x $y11 $item
	kdCreateBox $w $x $y22 $item
    }
}

itcl_class sel_line {
    inherit kdSelection
    constructor {coords config} {
	set i [eval $w create line $coords \
		-fill red]
	set item sel$i
	$w addtag $item withtag $i
	
	set par 0
	foreach yy $coords {
	    if $par then {
		kdCreateBox $w $xx $yy $item
	    }
	    set par [expr ! $par]
	    set xx $yy
	}
    }
}

proc destroyAll objects {
    set del ""
    foreach o $objects {
	lappend del [$o finish]
    }
    #puts "o:$objects   d:$del"
    foreach o [eval concat $del] {
	$o delete
    }
}

proc modify_object {class name} {
    global kdPriv kdModel dbvalues
    catch {destroy .mod}
    # !!! pevnej .mod ?
    set attr $kdModel(v,$class)
    #!!!
    #eval global $attr
    set sqlcom "select [join $attr ", "] from $class \
	    where name = '$name';"
    if [catch {set tuple [kdDBTuple $sqlcom]}] {
	kdDBInsert "insert into $class (name) values ('$name');"
	set tuple [kdDBTuple $sqlcom]
    }
    set i 0
    foreach a $attr {
	set dbvalues($name,$a) [lindex $tuple $i]
	incr i
    }
 
    toplevel .mod -class Dialog
    wm title .mod "Modify item"
    frame .mod.lab 
    frame .mod.atr -relief raised -bd 1
    frame .mod.but
    pack .mod.lab .mod.atr .mod.but -fill x -side top
    label .mod.lab.l -anchor w -text "Item: "
    label .mod.lab.n -anchor w -text $name \
	    -font -*-helvetica-medium-r-*-120-*
    pack .mod.lab.l .mod.lab.n -side left -fill x
    
    set en .mod.atr.en
    set la .mod.atr.la
    set i 1
    foreach a $attr {
	label $la$i -text $a 
	entry $en$i -textvariable dbvalues($name,$a) \
		-width $kdModel(vl,$class,$a)
	pack $la$i $en$i -side top -fill x
	incr i
    }
    
    set bu .mod.but
    button $bu.ok -text OK -command {set kdPriv(end) 1}
    button $bu.cancel -text cancel -command {set kdPriv(end) 0}
    pack $bu.ok $bu.cancel -side left -expand yes

    set oldFocus [focus]
    
    tkwait visibility .mod
    grab .mod
    focus .mod.atr

    tkwait variable kdPriv(end)
    if $kdPriv(end) {
	set vals ""
	foreach a $attr {
	    lappend vals "$a = '$dbvalues($name,$a)'"
	}
	kdDBExec "update $class set [join $vals ", "] where \
		name = '$name'"
    }
    destroy .mod
    catch {focus $oldFocus}
}

