proc kdLoadModel name {
    global kdOps
    set file $kdOps(diagDir)/$name.dia
    kdSaveProcs {object var class construct intersec}
    kdDefineModelProcs
    source $file
    kdRestoreProcs {object var class construct intersec}
}


proc kdDefineModelProcs {} {
    proc object {kdName kdBody} {
	global kdModel
	lappend kdModel(objects) $kdName
	set kdModel(v,$kdName) ""
	eval $kdBody
    }
    proc var {name len type} {
	upvar kdName kdName
	global kdModel
	lappend kdModel(v,$kdName) $name
	set kdModel(vl,$kdName,$name) $len
	set kdModel(vt,$kdName,$name) $type
    }
    proc connect {where class} {
	upvar kdName kdName
	global kdModel
	set kdModel(lconn,$kdName,$where) $class
    }
    proc check {where list} {
	upvar kdName kdName
	global kdModel
	set kdModel(lcheck,$kdName,$where) $list
    }
    proc class cl {
	upvar kdName kdName
	global kdModel
	set kdModel(cl,$kdName) $cl
    }
    proc construct body {
	upvar kdName kdName
	global kdModel
	set kdModel(constr,$kdName) $body
    }
    proc intersec body {
	upvar kdName kdName
	global kdModel
	set kdModel(intersec,$kdName) $body
    }
    proc style {style body} {
	upvar kdName kdName
	global kdModel
	set kdModel(style,$kdName,default) default 
	eval $body
    }
    proc create body {
	upvar kdName kdName  style style
	global kdModel
	set kdModel(create,$kdName,$style) $body
    }
}


proc kdSourceRC file {
    kdSaveProcs {option}

    proc option {name val} {
	global kdOps
	set kdOps($name) $val
    }

    source $file
    kdRestoreProcs {option}
}

proc kdDefineToolsProcs {} {
    proc newbox {icon object} {
    }

    proc choose {icon list} {
	#cara_r {entita relace}
	#cara_a {entita atribut}
    }
    proc command {icon comm} {
    }
}

